routes/web.php
<?php

use App\Http\Controllers\SliderController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('pages.welcome');
})->name('welcome');

Auth::routes();

Route::resource('user', UserController::class)->except('show');
Route::resource('slider', SliderController::class)->except('show');
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Slider.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Slider extends Model
{
    use HasFactory;
    protected $table = 'sliders';
    protected $primaryKey = 'id';
    protected $fillable = ['title','image','url'];
    public $timestamps = true;


    public function image()
    {
            return "/storage/{$this->image}";
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'image',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function image()
    {
        if ($this->image) {
            return "/storage/{$this->image}";
        }
        else
            return asset('argon/img/users/IMG_1856.PNG');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/SliderApiController.php
<?php

namespace App\Http\Controllers;

use App\Models\Slider;
use Illuminate\Http\Request;

class SliderApiController extends Controller
{

    public function index(Request $request)
    {
        if ($request->type == 'Specific'){
            $slider = Slider::where('url','!=',null)->get();
        }
        else $slider = Slider::where('url','=',null)->get();

        return response()->json($slider);
    }
}

app/Http/Controllers/SliderController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\SliderRequestForm;
use App\Models\Slider;
use App\Repositories\SliderRepository;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\Response;

class SliderController extends Controller
{

    private $repository;

    public function __construct(SliderRepository $repository)
    {
        $this->repository = $repository;
    }
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View|Response
     */
    public function index()
    {
        return view('sliders.index', ['data' => $this->repository->getAll()]);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|View|Response
     */
    public function create()
    {
        return view('sliders.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param SliderRequestForm $request
     * @return Response
     */
    public function store(SliderRequestForm $request)
    {
        $this->repository->create($request->all());

        return redirect()->route('slider.index')->withStatus(__('slider successfully created.'));
    }
    /**
     * Show the form for editing the specified resource.
     *
     * @param Slider $slider
     * @return Application|Factory|View|Response
     */
    public function edit(Slider $slider)
    {
        return view('sliders.edit', compact('slider'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param SliderRequestForm $request
     * @param $id
     * @return Response
     */
    public function update(SliderRequestForm $request ,$id)    {
        $this->repository->update($id,$request->all());

        return redirect()->route('slider.index')->withStatus(__('Slider successfully Updated.'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param $id
     * @return Response
     */
    public function destroy($id)
    {
        $this->repository->delete($id);

        return redirect()->route('slider.index')->withStatus(__('Slider successfully deleted.'));
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\UserRequestForm;
use App\Models\User;
use App\Repositories\UserRepository;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;

class UserController extends Controller
{
    private $repository;

    public function __construct(UserRepository $repository)
    {
        $this->repository = $repository;
    }

    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|Response|View|Application|Factory|View
     */
    public function index()
    {
        return view('users.index', ['data' => $this->repository->getAll()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Application|Factory|Response|View
     */
    public function create()
    {
        return view('users.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param UserRequestForm $request
     * @return Response
     */
    public function store(UserRequestForm $request)
    {
        $this->repository->create($request->all());

        return redirect()->route('user.index')->withStatus(__('User successfully created.'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param User $user
     * @return Application|Factory|Response|View
     */
    public function edit(User $user)
    {
        return view('users.edit', compact('user'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param UserRequestForm $request
     * @param $id
     * @return Response
     */
    public function update(UserRequestForm $request ,$id)
    {
        $this->repository->update($id,$request->all());

        return redirect()->route('user.index')->withStatus(__('User successfully Updated.'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param $id
     * @return RedirectResponse
     */
    public function destroy($id)
    {
        $this->repository->delete($id);

        return redirect()->route('user.index')->withStatus(__('User successfully deleted.'));
    }
}

resources/views/alerts/error_self_update.blade.php
@if ($errors->has($key))
    <div class="alert alert-danger alert-dismissible fade show" role="alert">
        {{ $errors->first($key) }} <br>
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
@endif

resources/views/alerts/errors.blade.php
@if (!$errors->isEmpty())
    <div class="alert alert-danger alert-dismissible fade show" role="alert">
        @foreach ($errors->all() as $error)
            {{ $error }} <br>
        @endforeach
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
@endif

resources/views/alerts/feedback.blade.php
@if ($errors->has($field))
    <span class="invalid-feedback" role="alert" style="display: block;{{-- This fixes a bootstrap known-issue --}}">
        <strong>{{ $errors->first($field) }}</strong>
    </span>
@endif

resources/views/alerts/migrations_check.blade.php
@if (!\Schema::hasTable((new \App\Models\User)->getTable()))
    <div class="alert alert-danger fade show" role="alert">
        {{ __('You did not run the migrations and seeders! The login information will not be available!') }}
    </div>
@endif

resources/views/alerts/success.blade.php
@if (session($key ?? 'status'))
    <div class="alert alert-success alert-dismissible fade show" role="alert">
        {{ session($key ?? 'status') }}
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
@endif

resources/views/forms/header.blade.php
<div class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center" style="background-image: url(../argon/img/theme/profile-cover.jpg); background-size: cover; background-position: center top;">
    <!-- Mask -->
    <span class="mask bg-gradient-default opacity-8"></span>
    <!-- Header container -->
    <div class="container-fluid d-flex align-items-center">
        <div class="row">
            <div class="col-md-12 {{ $class ?? '' }}">
                <h1 class="display-2 text-white">{{ $title }}</h1>
                @if (isset($description) && $description)
                    <p class="text-white mt-0 mb-5">{{ $description }}</p>
                @endif
            </div>
        </div>
    </div>
</div> 

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">{{ __('Dashboard') }}</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif

                    {{ __('You are logged in!') }}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/footers/auth.blade.php
<footer class="footer pt-0">
    @include('layouts.footers.nav')
</footer>

resources/views/layouts/footers/guest.blade.php
<footer class="py-5">
    <div class="container">
        @include('layouts.footers.nav')
    </div>
</footer>

resources/views/layouts/headers/auth.blade.php
<div class="header bg-primary pb-6">
    <div class="container-fluid">
        <div class="header-body">
           {{ $slot }} 
        </div>
    </div>
</div>

resources/views/users/create.blade.php
@extends('layouts.app', [
    'title' => __('User Management'),
    'parentSection' => 'laravel',
    'elementName' => 'user-management'
])
@push('css')
    <link href="{{asset('argon/libs/dropify/dropify.min.css')}}" rel="stylesheet" type="text/css" />
    <link href="{{asset('argon/css/app.min.css')}}" rel="stylesheet" type="text/css"  id="app-stylesheet" />

@endpush
@section('content')
    @component('layouts.headers.auth')
        @component('layouts.headers.breadcrumbs')
            @slot('title')
                {{ __('Examples') }}
            @endslot

            <li class="breadcrumb-item"><a href="{{ route('user.index') }}">{{ __('User Management') }}</a></li>
            <li class="breadcrumb-item active" aria-current="page">{{ __('Add User') }}</li>
        @endcomponent
    @endcomponent

    <div class="container-fluid mt--6">
        <div class="row">
            <div class="col-xl-12 order-xl-1">
                <div class="card">
                    <div class="card-header">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">{{ __('User Management') }}</h3>
                            </div>
                            <div class="col-4 text-right">
                                <a href="{{ route('user.index') }}" class="btn btn-sm btn-primary">{{ __('Back to list') }}</a>
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <form data-parsley-validate method="post" action="{{ route('user.store') }}" autocomplete="off"
                            enctype="multipart/form-data">
                            @csrf

                            <h6 class="heading-small text-muted mb-4">{{ __('User information') }}</h6>
                            <div class="row">
                                <div class="col-8">
                            <div class="pl-lg-4">

                                <div class="form-group">
                                    <label for="name">Name<span class="text-danger"></span></label>
                                    <input type="text" name="name" data-parsley-trigger="change"  required data-parsley-minlength="[4]"value="{{ old('name') }}"
                                           placeholder="Enter name" class="form-control" id="name">
                                    @if($errors->has('name'))
                                        <div class="error" style="color:red">{{ $errors->first('name') }}</div>
                                    @endif
                                </div>
                                <div class="form-group">
                                    <label for="input-email">Email<span class="text-danger"></span></label>
                                    <input type="email" name="email" data-parsley-trigger="change"  required value="{{ old('email') }}"
                                           placeholder="Enter name" class="form-control" id="name">
                                    @if($errors->has('email'))
                                        <div class="error" style="color:red">{{ $errors->first('email') }}</div>
                                    @endif
                                </div>
                                <div class="form-group">
                                    <label for="password">Password<span class="text-danger"></span></label>
                                    <input id="password" type="password"  placeholder="Password" data-parsley-trigger="change" data-parsley-minlength="[6]" required value="" name="password"
                                           class="form-control">
                                    @if($errors->has('password'))
                                        <div class="error" style="color: red">{{ $errors->first('password') }}</div>
                                    @endif
                                </div>

                                <div class="form-group">
                                    <label for="password2">Confirm Password <span class="text-danger"></span></label>
                                    <input data-parsley-equalto="#password"  type="password" data-parsley-trigger="change" data-parsley-minlength="[6]" required value="" name="password_confirmation"
                                           placeholder="Password" class="form-control" id="password2">
                                    @if($errors->has('password'))
                                        <div class="error" style="color: red">{{ $errors->first('password') }}</div>
                                    @endif
                                </div>
                                <div class="text-center">
                                    <button type="submit" class="btn btn-success mt-4">{{ __('Save') }}</button>
                                </div>
                            </div>
                                </div>

                                <div class="row">
                                    <div class="col-12">
                                        <div class="form-group">
                                            <div class="card-box">
                                                <label >Profile Photo<span class="text-danger"></span></label>
                                                <input  name="image" type="file" id="image" accept="image/*" class="dropify"/>
                                            </div>
                                            @if($errors->has('image'))
                                                <div class="error" style="color: red">{{ $errors->first('image') }}</div>
                                            @endif
                                        </div>
                                    </div>
                                    </div>
                                </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection
@push('js')
    <!-- Plugins js -->
    <script src="{{asset('argon/libs/dropify/dropify.min.js')}}"></script>

    <!-- Init js-->
    <script src="{{asset('argon/js/pages/form-fileuploads.init.js')}}"></script>


    <script src="{{asset('argon/libs/parsleyjs/parsley.min.js')}}"></script>

    <!-- Validation init js-->
    <script src="{{asset('argon/js/pages/form-validation.init.js')}}"></script>

@endpush

resources/views/users/edit.blade.php
@extends('layouts.app', [
    'title' => __('User Management'),
    'parentSection' => 'laravel',
    'elementName' => 'user-management'
])
@push('css')
    <link href="{{asset('argon/libs/dropify/dropify.min.css')}}" rel="stylesheet" type="text/css" />
    <link href="{{asset('argon/css/app.min.css')}}" rel="stylesheet" type="text/css"  id="app-stylesheet" />
@endpush
@section('content')
    @component('layouts.headers.auth')
        @component('layouts.headers.breadcrumbs')
            @slot('title')
                {{ __('Examples') }}
            @endslot

            <li class="breadcrumb-item"><a href="{{ route('user.index') }}">{{ __('User Management') }}</a></li>
            <li class="breadcrumb-item active" aria-current="page">{{ __('Edit User') }}</li>
        @endcomponent
    @endcomponent

    <div class="container-fluid mt--6">
        <div class="row">
            <div class="col-xl-12 order-xl-1">
                <div class="card">
                    <div class="card-header">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">{{ __('User Management') }}</h3>
                            </div>
                            <div class="col-4 text-right">
                                <a href="{{ route('user.index') }}" class="btn btn-sm btn-primary">{{ __('Back to list') }}</a>
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <form data-parsley-validate method="post" action="{{ route('user.update', $user) }}" autocomplete="off"
                            enctype="multipart/form-data">
                            @csrf
                            @method('put')

                            <h6 class="heading-small text-muted mb-4">{{ __('User information') }}</h6>
                            <div class="row">
                                <div class="col-8">
                                    <div class="pl-lg-4">

                                        <div class="form-group">
                                            <label for="name">Name<span class="text-danger"></span></label>
                                            <input type="text" name="name" data-parsley-trigger="change"  required data-parsley-minlength="[4]"value="{{ old('name',$user->name) }}"
                                                   placeholder="Enter name" class="form-control" id="name">
                                            @if($errors->has('name'))
                                                <div class="error" style="color:red">{{ $errors->first('name') }}</div>
                                            @endif
                                        </div>
                                        <div class="form-group">
                                            <label for="input-email">Email<span class="text-danger"></span></label>
                                            <input type="email" name="email" data-parsley-trigger="change"  required value="{{ old('email',$user->email) }}"
                                                   placeholder="Enter name" class="form-control" id="name">
                                            @if($errors->has('email'))
                                                <div class="error" style="color:red">{{ $errors->first('email') }}</div>
                                            @endif
                                        </div>
                                        <div class="form-group">
                                            <label for="password">Password<span class="text-danger"></span></label>
                                            <input id="password" type="password"  placeholder="Password" data-parsley-trigger="change" data-parsley-minlength="[6]"  value="" name="password"
                                                   class="form-control">
                                            @if($errors->has('password'))
                                                <div class="error" style="color: red">{{ $errors->first('password') }}</div>
                                            @endif
                                        </div>

                                        <div class="form-group">
                                            <label for="password2">Confirm Password <span class="text-danger"></span></label>
                                            <input data-parsley-equalto="#password"  type="password" data-parsley-trigger="change" data-parsley-minlength="[6]"  value="" name="password_confirmation"
                                                   placeholder="Password" class="form-control" id="password2">
                                            @if($errors->has('password'))
                                                <div class="error" style="color: red">{{ $errors->first('password') }}</div>
                                            @endif
                                        </div>
                                        <div class="text-center">
                                            <button type="submit" class="btn btn-success mt-4">{{ __('Save') }}</button>
                                        </div>
                                    </div>
                                </div>

                                <div class="row">
                                    <div class="col-12">
                                        <div class="form-group">
                                            <div class="card-box">
                                                <label >Profile Photo<span class="text-danger"></span></label>
                                                <input  name="image" type="file" id="image" accept="image/*" class="dropify" data-default-file="{{$user->image()}}"/>
                                            </div>
                                            @if($errors->has('image'))
                                                <div class="error" style="color: red">{{ $errors->first('image') }}</div>
                                            @endif
                                        </div>
                                    </div>
                                </div>
                            </div>

                        </form>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection
@push('js')
    <!-- Plugins js -->
    <script src="{{asset('argon/libs/dropify/dropify.min.js')}}"></script>

    <!-- Init js-->
    <script src="{{asset('argon/js/pages/form-fileuploads.init.js')}}"></script>


    <script src="{{asset('argon/libs/parsleyjs/parsley.min.js')}}"></script>

    <!-- Validation init js-->
    <script src="{{asset('argon/js/pages/form-validation.init.js')}}"></script>

@endpush

resources/views/users/index.blade.php
@extends('layouts.app', [
    'title' => __('User Management'),
    'parentSection' => 'laravel',
    'elementName' => 'user-management'
])

@section('content')
    @component('layouts.headers.auth')
        @component('layouts.headers.breadcrumbs')
            @slot('title')
                {{ __('Examples') }}
            @endslot

            <li class="breadcrumb-item"><a href="{{ route('user.index') }}">{{ __('User Management') }}</a></li>
            <li class="breadcrumb-item active" aria-current="page">{{ __('List') }}</li>
        @endcomponent
    @endcomponent

    <div class="container-fluid mt--6">
        <div class="row">
            <div class="col">
                <div class="card">
                    <div class="card-header">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">{{ __('Users') }}</h3>
                            </div>
                                <div class="col-4 text-right">
                                    <a href="{{ route('user.create') }}" class="btn btn-sm btn-primary">{{ __('Add user') }}</a>
                                </div>
                        </div>
                    </div>

                    <div class="col-12 mt-2">
                        @include('alerts.success')
                        @include('alerts.errors')
                    </div>

                    <div class="table-responsive py-4">
                        <table class="table align-items-center table-flush"  id="datatable-basic">
                            <thead class="thead-light">
                                <tr>
                                    <th scope="col">{{ __('Photo') }}</th>
                                    <th scope="col">{{ __('Name') }}</th>
                                    <th scope="col">{{ __('Email') }}</th>
                                    <th scope="col">{{ __('Creation Date') }}</th>
                                    <th scope="col">{{ __('Actions') }}</th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach ($data as $user)
                                    <tr>
                                        <td>
                                             <span class="avatar avatar-sm rounded-circle">
                                                 <img src="{{$user->image()}}" alt="" width="40px" height="40px" style="border-radius: 25px">
                                              </span>
                                        </td>
                                        <td>{{ $user->name }}</td>
                                        <td>
                                            <a href="mailto:{{ $user->email }}">{{ $user->email }}</a>
                                        </td>
                                        <td>{{ $user->created_at->format('d/m/Y H:i') }}</td>
                                            <td class="text-right">
                                                    <div class="dropdown">
                                                        <a class="btn btn-sm btn-icon-only text-light" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                            <i class="fas fa-ellipsis-v"></i>
                                                        </a>
                                                        <div class="dropdown-menu dropdown-menu-right dropdown-menu-arrow">
                                                            <a class="dropdown-item" href="{{ route('user.edit', $user) }}">{{ __('Edit') }}</a>

                                                            <form action="{{ route('user.destroy', $user) }}" method="post">
                                                                        @csrf
                                                                        @method('delete')
                                                                        <button type="button" class="dropdown-item" onclick="confirm('{{ __("Are you sure you want to delete this user?") }}') ? this.parentElement.submit() : ''">
                                                                            {{ __('Delete') }}
                                                                        </button>
                                                                    </form>
                                                        </div>
                                                    </div>
                                            </td>
                                    </tr>
                                @endforeach
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

        @include('layouts.footers.auth')
    </div>
@endsection

@push('css')
    <link rel="stylesheet" href="{{ asset('argon') }}/vendor/datatables.net-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="{{ asset('argon') }}/vendor/datatables.net-buttons-bs4/css/buttons.bootstrap4.min.css">
    <link rel="stylesheet" href="{{ asset('argon') }}/vendor/datatables.net-select-bs4/css/select.bootstrap4.min.css">
@endpush

@push('js')
    <script src="{{ asset('argon') }}/vendor/datatables.net/js/jquery.dataTables.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/datatables.net-bs4/js/dataTables.bootstrap4.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/datatables.net-buttons/js/dataTables.buttons.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/datatables.net-buttons-bs4/js/buttons.bootstrap4.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/datatables.net-buttons/js/buttons.html5.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/datatables.net-buttons/js/buttons.flash.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/datatables.net-buttons/js/buttons.print.min.js"></script>
    <script src="{{ asset('argon') }}/vendor/datatables.net-select/js/dataTables.select.min.js"></script>
@endpush